if(!dojo._hasResource["com.ibm.mm.builder.iwidget.freeformlayout.freeformUtil"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.iwidget.freeformlayout.freeformUtil"] = true;
dojo.provide("com.ibm.mm.builder.iwidget.freeformlayout.freeformUtil");

com.ibm.mm.builder.iwidget.freeformlayout.freeformUtil.LOGGER = com.ibm.mashups.enabler.logging.Logger.getLogger("com.ibm.mm.builder.iwidget.freeformlayout.freeformUtil");

/**
 * get widget from free form layout
 * @return an array which contains widget dom node
 */			
com.ibm.mm.builder.iwidget.freeformlayout.freeformUtil.getWidgetsFromLayout = function(){
	var freeformId = com.ibm.mm.builder.freeLayOutBean.getWidgetId();
	var widgetsContainerNode = dojo.byId("_"+freeformId+"_container").cloneNode(true);
	var queryResult = dojo.query("." + com.ibm.mm.builder.constant.mmIWidget,widgetsContainerNode);
	//OpenSocial support change
	queryResult = queryResult + dojo.query("." + com.ibm.mm.builder.constant.mmGGadget,widgetsContainerNode);
	var len = queryResult.length;
	var widgets = [];
	for (var i=0;i<len;i++){
		var contentElems = dojo.query("." + com.ibm.mm.builder.constant.iWidgetContent,queryResult[i]);
		if (contentElems.length>0){
			var contentElem = contentElems[0];
			queryResult[i].removeChild(contentElem);
			widgets.push(queryResult[i]);	
		}else{
			widgets.push(queryResult[i]);
		}
	}
	return widgets;
};
	
com.ibm.mm.builder.iwidget.freeformlayout.freeformUtil.createSkinConfigUI = function(skinDivId,wid){
	var skinConfig = dojo.byId(skinDivId);
	com.ibm.mm.builder.utils.layoutUtil.removeAllChildren(skinConfig);
	var skins = com.ibm.mm.builder.utils.skinUtil.getAllSkins();
	if (skins.length > 0) {
        com.ibm.mm.builder.freeLayOutBean.skinObjects = [];
		dojo.forEach(skins, function(skin){
			//TODO:BUG1901: No localed title for noSkin and thinSkin in Skin Model
			var skinTitle = skin.getTitle(dojo.locale);
			if(ibmConfig["default.locale"] != dojo.locale && (null === skinTitle || "" == skinTitle)) {
				skinTitle = skin.getTitle(ibmConfig["default.locale"]);
			}				
			if (!skin.getMetaData("com.ibm.mashups.builder.skin.nva")){
				com.ibm.mm.builder.freeLayOutBean.skinObjects.push(skin);
				var fathDiv = document.createElement("div");
				skinConfig.appendChild(fathDiv);
				dojo.addClass(fathDiv,"skinPreviewDiv");
				
				var funcName = "com.ibm.mm.builder.iwidget.freeformlayout.freeformUtil.chooseSkin(\""+ skin.getID() + "\",\"" +  wid + "\")";
				var funcNameWithKey = "com.ibm.mm.builder.iwidget.freeformlayout.freeformUtil.chooseSkinWithKey(event,\"" + skin.getID() + "\",\"" + wid + "\")";				
				var inner = "<DIV align='center' id='" + wid + "_" + skin.getID();
				inner = inner + "' style='margin-top:4px;' onclick='";
				inner = inner + "eval(" + funcName + ");' onkeypress='";
				inner = inner + "eval(" + funcNameWithKey + ");'>";
				inner = inner + "<IMG tabindex='0' src='" + skin.getPreviewUrl() + "' alt='" + skinTitle + "' orig_title='" + skinTitle + "' title='" + skinTitle + "' id='" + wid + "_" + skin.getID() + "_img" + "'/></DIV>";
				fathDiv.innerHTML = inner;
			}
	    });
    } else {
    	com.ibm.mm.builder.iwidget.freeformlayout.freeformUtil.LOGGER.severe("createSkinConfigUI",com.ibm.mm.builder.coreWidgetsMessages.E_LAYOUT_UTIL_CREATE_SKIN_CONF_0);
	}
};

com.ibm.mm.builder.iwidget.freeformlayout.freeformUtil.chooseSkinWithKey = function(event, skinvalue, wid){
    var keyCode = event.keyCode;
    if (keyCode != dojo.keys.ENTER) {
		return true;
	}
    com.ibm.mm.builder.iwidget.freeformlayout.freeformUtil.chooseSkin(skinvalue, wid);
};	
	/**
	 * chooseSkin is called when click the different skin type in configuration pane
	 * @param {Object} skinvalue
	 */
com.ibm.mm.builder.iwidget.freeformlayout.freeformUtil.chooseSkin = function(skinvalue,wid){
	this.containerSkinValue = skinvalue;
	com.ibm.mm.builder.freeLayOutBean.setSelectedSkin(skinvalue);
	var skins = com.ibm.mm.builder.utils.skinUtil.getAllSkins();
    if (skins.length > 0) {
		dojo.forEach(skins, function(skin){
	        if (!skin.getMetaData("com.ibm.mashups.builder.skin.nva")) {
				var skinUIDiv = dojo.byId(wid+"_"+skin.getID());
				var img = dojo.byId(wid+"_"+skin.getID() + "_img");
				if (skinvalue == skin.getID()){
					skinUIDiv.parentNode.style.border = "1px solid";
					skinUIDiv.parentNode.style.borderColor = "#739DD7";
					skinUIDiv.parentNode.style.backgroundColor = "#BED2EE";
					var skinTitle = dojo.string.substitute(com.ibm.mm.builder.coreWidgetsStrings.I_FREEFORM_CONF_SKIN_SELECTED,[img.getAttribute('orig_title')]);
					img.setAttribute('alt',skinTitle);
					img.setAttribute("title",skinTitle);
				}else{
					skinUIDiv.parentNode.style.border = "1px solid";
					skinUIDiv.parentNode.style.borderColor = "#F3F3F3";		
					skinUIDiv.parentNode.style.backgroundColor = "";				
					img.setAttribute('title', img.getAttribute('orig_title'));
					img.setAttribute('alt', img.getAttribute('orig_title'));
				}
	        }
	    });
    } else {
    	com.ibm.mm.builder.iwidget.freeformlayout.freeformUtil.LOGGER.severe("chooseSkin",com.ibm.mm.builder.coreWidgetsMessages.E_LAYOUT_UTIL_CHOOSE_SKIN_0);
	}		
};

com.ibm.mm.builder.iwidget.freeformlayout.freeformUtil.validatePageMetaData = function(metadataObj){
	if (metadataObj.backgroundimagetype && metadataObj.backgroundimage && metadataObj.pagebgcolor && metadataObj.backgroundimageproperty){
		return metadataObj;
	} else {
		var defaultItemSet=new com.ibm.mm.builder.iwidget.freeformlayout.defaultSettings();
		return dojo.mixin(defaultItemSet.getPageDefaultSetting(),defaultItemSet.getWidgetDefaultSetting(), metadataObj);
	}
};

com.ibm.mm.builder.iwidget.freeformlayout.freeformUtil._setTitleForColorNode = function(node,perfixTitle){
    var color = dojo.style(node, "backgroundColor");
    var titleSubstuite = com.ibm.mm.builder.coreWidgetsStrings.I_FREEFORM_CONF_PAGE_COLOR_PICKER_COLOR_TITLE;
    var title;
    if (color.indexOf("rgb") != -1) {
        var rgb = color.substring(4, color.length - 1);
        var rgbArray = rgb.split(",");
        title = dojo.string.substitute(titleSubstuite, [rgbArray[0], rgbArray[1], rgbArray[2]]);
    }
    else {
        var inHexStr = color.substring(color.length - 6);
        var red = parseInt("0x" + inHexStr.substr(0, 2), 16);
        var green = parseInt("0x" + inHexStr.substr(2, 2), 16);
        var blue = parseInt("0x" + inHexStr.substr(4, 2), 16);
        title = dojo.string.substitute(titleSubstuite, [red, green, blue]);
    }
    if (perfixTitle.indexOf(":") == -1) {
		dojo.attr(node, "title", perfixTitle + ":" + title);
	}
	else{
		dojo.attr(node, "title", perfixTitle + title);
	}
};
	

}
