dojo.require("com.ibm.mm.builder.iwidget.SystemWidget");
dojo.require("com.ibm.mm.catalog.hubUtil");
dojo.require("com.ibm.mashups.enabler.logging.Logger");
dojo.require("com.ibm.mashups.services.ServiceManager");
dojo.require("com.ibm.mashups.enabler.services.ConfigService");
dojo.require("com.ibm.mashups.enabler.ac.AccessControlModelFactory");
dojo.require("com.ibm.mashups.enabler.model.url.ModelUrlFactory");
dojo.declare("com.ibm.mm.builder.publishWidget",com.ibm.mm.builder.iwidget.SystemTemplatedWidget,{WID:null,space:null,LOGGER:com.ibm.mashups.enabler.logging.Logger.getLogger(this.declaredClass),onLoad:function(){
var _1=this.iContext.widgetId;
this.WID="_"+_1+"_";
},onView:function(){
this.inherited(arguments);
},onPublishPage:function(_2){
this.permPageRadio.checked=true;
this.smRadio.checked=true;
var _3=dojo.byId(this.WID+"pageRoot");
var _4=dojo.byId(this.WID+"spaceRoot");
dojo.style(_3,"display","block");
dojo.style(_4,"display","none");
if(_2.payload){
this.pageId=_2.payload;
this.updatePageUI();
}
},onPublishSpace:function(_5){
this.permRadio.checked=true;
var _6=dojo.byId(this.WID+"pageRoot");
var _7=dojo.byId(this.WID+"spaceRoot");
dojo.style(_7,"display","block");
dojo.style(_6,"display","none");
var _8=null;
if(_5.payload){
_8=_5.payload;
var _9=com.ibm.mm.builder.utils.spaceUtil;
this.spaceModel=_9.getSpaceModel();
this.space=this.spaceModel.find(_8).start();
this.updateSpaceUI();
}
},updatePageUI:function(){
var pu=com.ibm.mm.builder.utils.pageUtil;
this.pageName=pu.getUnescapedPageTitle(this.pageId);
this.titlePageInput.value=this.pageName;
this.descPageInput.value=pu.getPageDescription(this.pageId)||"";
this.versionPageInput.value="1.0";
this.tagPageInput.value="";
this.pageStatusDiv.innerHTML="";
this._enableSaveButton();
},showPageErrorMsg:function(_a){
this.pageStatusDiv.innerHTML="<font color=red>"+_a+"</font>";
dojo.attr(this.pageStatusDiv,"role","alert");
},showPageInfoMsg:function(_b){
this.pageStatusDiv.innerHTML="<font color=gray>"+_b+"</font>";
dojo.attr(this.pageStatusDiv,"role","alert");
},showSpaceErrorMsg:function(_c){
this.spaceStatusDiv.innerHTML="<font color=red>"+_c+"</font>";
dojo.attr(this.spaceStatusDiv,"role","alert");
},showSpaceInfoMsg:function(_d){
this.spaceStatusDiv.innerHTML="<font color=gray>"+_d+"</font>";
dojo.attr(this.spaceStatusDiv,"role","alert");
},_validatePageInput:function(_e,_f,_10){
if(!(_e&&_10)){
this.showPageErrorMsg(this.cws.E_PUBLISH_PAGE_REQUIRED_FIELDS_EMPTY_0);
if(!_e){
dojo.attr(this.titlePageInput,"aria-invalid","true");
}
if(!_10){
dojo.attr(this.versionPageInput,"aria-invalid","true");
}
return false;
}
if(!com.ibm.mm.builder.utils.pageUtil.validatePageName(_e)){
return false;
}
dojo.removeAttr(this.titlePageInput,"aria-invalid");
dojo.removeAttr(this.versionPageInput,"aria-invalid");
return true;
},_savePublishPageWithKey:function(e){
if(e.charCode==dojo.keys.SPACE||e.keyCode==dojo.keys.ENTER){
this.savePublishPage();
}
},savePublishPage:function(){
var _11=dojo.trim(this.titlePageInput.value);
var _12=dojo.trim(this.descPageInput.value);
var _13=dojo.trim(this.versionPageInput.value);
var _14=dojo.trim(this.tagPageInput.value);
var _15=this.permPageRadio.checked;
var _16=!this.smRadio.checked;
if(!this._validatePageInput(_11,_12,_13)){
return;
}
this._disableSaveButton();
var _17=null;
var _18=com.ibm.mm.builder.utils.pageUtil.getPageNode(this.pageId);
if(_18!==null){
var _19=_18.getExportPageURL();
if(_19!==null){
_17=_19+"&mime-type=application/zip&rep=template";
}
}
if(_17===null){
var cs=com.ibm.mashups.services.ServiceManager.getService(com.ibm.mashups.enabler.services.ConfigService.SERVICE_NAME);
_17=cs.getValue(com.ibm.mashups.enabler.services.ConfigConstants.CONTEXT_ROOT)+"/mycontenthandler?uri=resource:"+this.pageId;
}
this._publishPageToCatalog(_17,_11,_12,_13,_14,_16,_15);
},_publishPageToCatalog:function(_1a,_1b,_1c,_1d,_1e,_1f,_20){
var _21=this._buildPageAtomXmlToPost(_1a,_1b,_1c,_1d,_1e,_1f,_20);
var _22=com.ibm.mm.catalog.hubUtil.getDefaultHubUrl()+"/atom";
this.showPageInfoMsg(this.cws.I_PUBLISH_PUBLISHING);
com.ibm.mm.catalog.hubUtil.openSearchPost(dojo.hitch(this,function(_23){
dojo.rawXhrPost({headers:{"Content-Type":"application/xml"},url:this.iContext.io.rewriteURI(_23+"?collection=pages"),load:dojo.hitch(this,function(_24,_25){
this.LOGGER.info("_publishPageToCatalog",dojo.string.substitute(this.cwm.I_PUBLISH_PAGE_1,[_1b]));
this.hide();
}),error:dojo.hitch(this,function(_26,_27){
var _28=this.cws.E_PUBLISH_PAGE_PUBLISH_FAILED_MSG_0;
this.showPageErrorMsg(_28);
}),postData:_21,handleAs:"text"});
}),_22);
},_getPageDefinition:function(_29){
var _2a=dojo.string.substitute(this.cws.I_PUBLISH_PAGE_EXPORTING_PAGE_1,[_29]);
this.showPageInfoMsg(_2a);
var _2b="";
dojo.xhrGet({url:_29,load:dojo.hitch(this,function(_2c,_2d){
this.showPageInfoMsg("");
_2b=com.ibm.mm.builder.utils.pageUtil.encodeBase64(_2c);
}),error:dojo.hitch(this,function(_2e,_2f){
this.LOGGER.severe("_buildPageAtomXmlToPost",dojo.string.substitute(this.cwm.E_PUBLISH_PAGE_EXPLORTING_PAGE_1,[_2f]));
return _2e;
}),sync:true,handleAs:"text"});
return _2b;
},_buildPageAtomXmlToPost:function(_30,_31,_32,_33,_34,_35,_36){
var _37=[];
var _38=function(str){
return (typeof str=="undefined")?"":str.toString().replace(/&/gm,"&amp;").replace(/</gm,"&lt;").replace(/>/gm,"&gt;").replace(/"/gm,"&quot;").replace(/'/gm,"&#39;").replace(/\[/gm,"&#91;").replace(/\]/gm,"&#93;");
};
_34=_34.replace(/\s+/g,",");
return dojo.string.substitute("<?xml version=\"1.0\" encoding=\"UTF-8\"?>"+"<entry xmlns=\"http://www.w3.org/2005/Atom\">"+"<id>urn:id:0</id>"+"<category term=\"mashuppage\"></category>"+"<content type=\"application/xml\">"+"<catalog:mashuppage xmlns:catalog=\"http://www.ibm.com/xmlns/atom/opensearch/mashuppage/1.0/\">"+"<catalog:version xmlns:catalog=\"http://www.ibm.com/xmlns/atom/opensearch/mashuppage/1.0/\">${0}</catalog:version>"+"<catalog:name xmlns:catalog=\"http://www.ibm.com/xmlns/atom/opensearch/mashuppage/1.0/\">${1}</catalog:name>"+"<catalog:author xmlns:catalog=\"http://www.ibm.com/xmlns/atom/opensearch/mashuppage/1.0/\">${2}</catalog:author>"+"<catalog:description xmlns:catalog=\"http://www.ibm.com/xmlns/atom/opensearch/mashuppage/1.0/\">${3}</catalog:description>"+"<catalog:tags xmlns:catalog=\"http://www.ibm.com/xmlns/atom/opensearch/mashuppage/1.0/\">${4}</catalog:tags>"+"<catalog:documentation xmlns:catalog=\"http://www.ibm.com/xmlns/atom/opensearch/mashuppage/1.0/\"></catalog:documentation>"+"<catalog:documentationURL xmlns:catalog=\"http://www.ibm.com/xmlns/atom/opensearch/mashuppage/1.0/\"></catalog:documentationURL>"+"${5}"+"<catalog:permission xmlns:catalog=\"http://www.ibm.com/xmlns/atom/opensearch/mashuppage/1.0/\">"+(_36?"public":"private")+"</catalog:permission>"+"</catalog:mashuppage>"+"</content>"+"<author><name>Mashuphub Search Feed</name></author>"+"<title type=\"html\">new page</title>"+"</entry>",[_38(_33),_38(_31),_38(this.iContext.getUserProfile().user.getID()),_38(_32),(_34?dojo.map(_34.split(","),function(tag){
return tag?"<catalog:tag xmlns:catalog=\"http://www.ibm.com/xmlns/atom/opensearch/mashuppage/1.0/\">"+_38(tag)+"</catalog:tag>":"";
}).join(""):""),(_35?"<catalog:definitionURL xmlns:catalog=\"http://www.ibm.com/xmlns/atom/opensearch/mashuppage/1.0/\">"+_38(com.ibm.mm.builder.utils.navigationUtil.getRedirectAddress())+"</catalog:definitionURL>":"<catalog:packageURL xmlns:catalog=\"http://www.ibm.com/xmlns/atom/opensearch/mashuppage/1.0/\">"+_38(_30)+"</catalog:packageURL>")]);
},_getSpaceOwnerId:function(){
this.acModel=com.ibm.mashups.enabler.ac.AccessControlModelFactory.getAccessControlModel(this.space);
if(this.acModel.getOwner()){
return this.acModel.getOwner().getID();
}else{
return null;
}
},updateSpaceUI:function(){
this.titleInput.value=this.space.getTitle(dojo.locale)||"";
this.descInput.value=this.space.getDescription(dojo.locale)||"";
this.versionInput.value="1.0";
this.tagInput.value="";
this._enableSaveButton();
this.spaceStatusDiv.innerHTML="";
},_validateInput:function(_39,_3a,_3b){
if(!(_39&&_3a&&_3b)){
this.showSpaceErrorMsg(this.cws.E_PUBLISH_SPACE_REQUIRED_FIELDS_EMPTY_0);
if(!_39){
dojo.attr(this.titleInput,"aria-invalid","true");
}
if(!_3a){
dojo.attr(this.descInput,"aria-invalid","true");
}
if(!_3b){
dojo.attr(this.versionInput,"aria-invalid","true");
}
return false;
}
if(!com.ibm.mm.builder.utils.spaceUtil.validateSpaceName(_39)){
return false;
}
dojo.removeAttr(this.titleInput,"aria-invalid");
dojo.removeAttr(this.descInput,"aria-invalid");
dojo.removeAttr(this.versionInput,"aria-invalid");
return true;
},savePublishSpace:function(){
var _3c=dojo.trim(this.titleInput.value);
var _3d=dojo.trim(this.descInput.value);
var _3e=dojo.trim(this.versionInput.value);
var _3f=dojo.trim(this.tagInput.value);
var _40=this.permRadio.checked;
if(!this._validateInput(_3c,_3d,_3e)){
return;
}
this._disableSaveButton();
var _41=this.space.getExportTemplateURL();
var _42=com.ibm.mashups.enabler.model.url.ModelUrlFactory.getModelUrl(_41,com.ibm.mm.builder.utils.spaceUtil.getSpaceModel());
this._publishToCatalog(_42.getAbsoluteURL(),_3c,_3d,_3e,_3f,_40);
},_publishToCatalog:function(_43,_44,_45,_46,_47,_48){
var _49=this._buildAtomXmlToPost(_43,_44,_45,_46,_47,_48);
var _4a=com.ibm.mm.catalog.hubUtil.getDefaultHubUrl()+"/atom";
com.ibm.mm.catalog.hubUtil.openSearchPost(dojo.hitch(this,function(_4b){
dojo.rawXhrPost({headers:{"Content-Type":"application/xml"},url:this.iContext.io.rewriteURI(_4b+"?collection=spaces"),load:dojo.hitch(this,function(_4c,_4d){
this.LOGGER.info("_publishToCatalog",dojo.string.substitute(this.cwm.I_PUBLISH_SPACE_1,[_44]));
this.hide();
}),error:dojo.hitch(this,function(_4e,_4f){
var _50=this.cws.E_PUBLISH_PAGE_PUBLISH_FAILED_MSG_0;
this.showSpaceErrorMsg(_50);
}),postData:_49,handleAs:"text"});
}),_4a);
},_buildAtomXmlToPost:function(_51,_52,_53,_54,_55,_56){
var _57=[];
var _58=function(str){
return (typeof str=="undefined")?"":str.toString().replace(/&/gm,"&amp;").replace(/</gm,"&lt;").replace(/>/gm,"&gt;").replace(/"/gm,"&quot;").replace(/'/gm,"&#39;").replace(/\[/gm,"&#91;").replace(/\]/gm,"&#93;");
};
var _59=false;
var _5a=this._getSpaceOwnerId();
if(!_5a){
_5a="";
}
_55=_55.replace(/\s+/g,",");
return dojo.string.substitute("<?xml version=\"1.0\" encoding=\"UTF-8\"?>"+"<entry xmlns=\"http://www.w3.org/2005/Atom\">"+"<id>urn:id:0</id>"+"<category term=\"spacetemplate\"></category>"+"<content type=\"application/xml\">"+"<catalog:spacetemplate xmlns:catalog=\"http://www.ibm.com/xmlns/atom/opensearch/spacetemplate/1.0/\">"+"<catalog:version xmlns:catalog=\"http://www.ibm.com/xmlns/atom/opensearch/spacetemplate/1.0/\">${0}</catalog:version>"+"<catalog:name xmlns:catalog=\"http://www.ibm.com/xmlns/atom/opensearch/spacetemplate/1.0/\">${1}</catalog:name>"+"<catalog:author xmlns:catalog=\"http://www.ibm.com/xmlns/atom/opensearch/spacetemplate/1.0/\">${2}</catalog:author>"+"<catalog:description xmlns:catalog=\"http://www.ibm.com/xmlns/atom/opensearch/spacetemplate/1.0/\">${3}</catalog:description>"+"<catalog:tags xmlns:catalog=\"http://www.ibm.com/xmlns/atom/opensearch/spacetemplate/1.0/\">${4}</catalog:tags>"+"<catalog:documentation xmlns:catalog=\"http://www.ibm.com/xmlns/atom/opensearch/spacetemplate/1.0/\"></catalog:documentation>"+"<catalog:documentationURL xmlns:catalog=\"http://www.ibm.com/xmlns/atom/opensearch/spacetemplate/1.0/\"></catalog:documentationURL>"+"<catalog:packageURL xmlns:catalog=\"http://www.ibm.com/xmlns/atom/opensearch/spacetemplate/1.0/\">${5}</catalog:packageURL>"+"<catalog:permission xmlns:catalog=\"http://www.ibm.com/xmlns/atom/opensearch/spacetemplate/1.0/\">"+(_56?"public":"private")+"</catalog:permission>"+"</catalog:spacetemplate>"+"</content>"+"<author><name>Mashuphub Search Feed</name></author>"+"<title type=\"html\">new space</title>"+"</entry>",[_58(_54),_58(_52),_58(_5a),_58(_53),(_55?dojo.map(_55.split(","),function(tag){
return tag?"<catalog:tag xmlns:catalog=\"http://www.ibm.com/xmlns/atom/opensearch/spacetemplate/1.0/\">"+_58(tag)+"</catalog:tag>":"";
}).join(""):""),_58(_51)]);
},_getTags:function(_5b){
var str=_5b.replace(/\S/g,",");
var _5c=str.split(",");
var _5d="<catalog:tag xmlns:catalog=\"http://www.ibm.com/xmlns/atom/opensearch/spacetemplate/1.0/\">";
var _5e="</catalog:tag>";
var _5f="";
for(var i=0;i<_5c.length;i++){
_5f=_5f+_5d+_5c[i]+_5e;
}
return _5f;
},_hideWithKey:function(e){
if(e.charCode==dojo.keys.SPACE||e.keyCode==dojo.keys.ENTER){
this.hide();
}
},hide:function(){
this.eventService.broadcastEvent("com.ibm.mashups.builder.closeMashupDialog",this.iContext.widgetId);
},_disableSaveButton:function(){
this.savePageButton.disabled=true;
},_enableSaveButton:function(){
this.savePageButton.disabled=false;
}});

