<%-- Copyright IBM Corp. 2009, 2011.  All Rights Reserved. --%>
<%-- Required login header JSP, do not remove! --%>
<%@ page language="java" contentType="text/html; charset=UTF-8" session="false" %>
<%@page import="java.net.URLEncoder" %>
<%@page import="java.net.HttpURLConnection" %>
<%@page import="java.net.URL" %>
<%@page import="javax.servlet.http.HttpServletResponse" %>
<%@page import="java.io.BufferedReader" %>
<%@page import="java.io.InputStreamReader" %>
<%!

	String getUrlContent(String path) {
	String content = "";
	try {
		URL u = new URL(path);
		HttpURLConnection c = (HttpURLConnection) u.openConnection();
		if (c.getResponseCode() == HttpServletResponse.SC_OK) {
			BufferedReader r = new BufferedReader(new InputStreamReader(c.getInputStream()));
			String line = r.readLine();
			while (line != null) {
				if (content.length() > 0) {
					content = content + '\n';
				}
				content = content + line;
				line = r.readLine();
			}
		}
	} catch (Exception e) {
		// ignore errors if we can't read content since this is an
		// optional background operation 
	}
	return content;
}

%>
<%@include file="login_header.jsp" %>
<% 
	String mmContextRoot = configService.getString(com.ibm.mm.ConfigConstants.CONTEXT_ROOT_MYMASHUPS, 
	configService.getString(com.ibm.mm.ConfigConstants.CONTEXT_ROOT_MAIN, "/mum"));
	
	com.ibm.mm.framework.services.IConfigService endPointService = com.ibm.mm.framework.Platform.getInstance().getConfigService("Endpoints");
	String bspaceContextRoot = endPointService.getString("{com.ibm.bspace}bspaceWidgetRootId.url", "/BusinessSpace/");

		
   if (!com.ibm.mm.framework.Platform.getInstance().isSecurityEnabled()) {
       final String cookieName = com.ibm.mm.framework.rest.next.servlet.Constants.SECURITY_OFF_COOKIE_NAME;//"valid_user";
       Boolean valid_user = false;

        Cookie cookies [] = request.getCookies ();
	    if (cookies != null)
	    {
		    for (int i = 0; i < cookies.length; i++) 
		    {
			    if (cookies [i].getName().equals (cookieName))
			    {
				    valid_user = true;
				    break;
			    }
		    }
	    }

       if (valid_user) { 
            response.sendRedirect(mmContextRoot + "/enabler");
       }
   }
   
   String serverPrefix = request.getScheme()+"://"+request.getServerName()+":"+request.getServerPort(); 
   
%>




<!-- BS scripts - start -->

<script type="text/javascript">
dojo.registerModulePath("com.ibm.bspace.common.util.ui", "<%=bspaceContextRoot%>com/ibm/bspace/common/util/ui");
dojo.require("dojo.i18n");
dojo.require('com.ibm.bspace.common.util.ui.bspacecommonui');
dojo.require('com.ibm.bspace.common.util.ui.Helper');
dojo.require('com.ibm.bspace.common.util.ui.ComboBox');
dojo.require('com.ibm.bspace.common.util.ui.FilteringSelect');
//dojo.hostenv.writeIncludes()

	
	// Defect 64103
	dojo.require("dojo.cookie");
	var tempPastDate = new Date();
	tempPastDate.getHours() - 2;
	// document.cookie ='com_ibm_bpm_bspace_logout; expires='+  tempPastDate.toGMTString() +'; path=/';	
	dojo.cookie("com_ibm_bpm_bspace_logout", null, {expires: -1, path: "<%=mmContextRoot%>/"});


    var locale = "<%=request.getLocale().toString().toLowerCase().replace('_','-')%>";
    var mesages = null;
    try {
        dojo.registerModulePath("banner","<%=bspaceContextRoot%>login");
        dojo.requireLocalization("banner","bannerResources",locale,"ar,cs,de,el,es,fr,he,hu,it,iw,ja,ko,pl,pt,pt-br,ro,ru,tr,zh,zh-tw,da,fi,nb,sk,sv,nl,no");
        messages = dojo.i18n.getLocalization("banner","bannerResources",locale);
    } catch (ex) {
        // localization failed!!!! what can/should we do now
        alert('Error loading locale specific text.');
        messages = { welcome:			"Welcome! Enter your information",
			         user_id:			"User ID :",
		        	 password:			"Password :",
					 log_in:			"Log in",
		        	 username_required:	"Username is required",
		        	 password_required:	"Password is required",
		        	 returnToLastPage: 	"Manage Business Spaces"};
    }

    var productName="<%=configService.getString(com.ibm.mm.ConfigConstants.PRODUCT_NAME)%>";
    window.document.title = (productName == "Business Space") ? messages.title : productName;


    function nlsFix(id) {
    	var e = document.getElementById(id);
    	if (e) {
    		var msg_txt;
    		// the field with id 'password_label' needs to use the message called 'password' 
    		if (id == 'password_label') msg_txt = messages['password']; 
    		else msg_txt = messages[id];
    		if (e.nodeName == 'INPUT') {
    			e.value = msg_txt;
    		} else {
	    		e.appendChild(document.createTextNode(msg_txt));
    		}
    	}
    }    
    
    // defect 102305
	function prepareBeforeSubmitLogin () {
    	// defect 99973
    	// Somehow the first redirect will have the WASReqURL set to undefined in IE which cause the 404 error
    	// The fix here is to make sue if the WASReqURL has the undefined pattern, we will replace with the correct pattern
    	if (dojo.isIE) {
    		var tempCookies = getCookie("WASReqURL");
    		var wrongURL = "<%=enablerContext%>/undefined";
    		if (tempCookies && tempCookies.indexOf(wrongURL) > 0) {
    			var rightURL = tempCookies.replace(wrongURL, "<%=publicHome%>");
    			setCookie("WASReqURL", rightURL);
    		}
    	}
		
		// defect 71811
		var legacyForwardPageCookie = getCookie("legacyForwardPage");
		if (legacyForwardPageCookie != null) {
			setCookie("WASReqURL", legacyForwardPageCookie);
			
			// Cleanup the legacyForwardPage cookie
			dojo.require("dojo.cookie");
			dojo.cookie("legacyForwardPage", null, {expires: -1, path: "/"});
		}

		// d104158: Don't call submitLogin if any of the fields are empty.
		if ((textboxUser.value.length > 0)
<% if (com.ibm.mm.framework.Platform.getInstance().isSecurityEnabled()) { %>
	   && (textboxPassword.value.length) > 0
<% } %> )
		{
  	 		submitLogin();
  	 	} else {
  	 		showLoginErrorMessage();
  	 	}
	}

	function showLoginErrorMessage() {
		document.getElementById('loginFailedMessage').style.display = '';
	}

	function prepareBeforeSubmitLoginUnsecure() {
		var rc = true;
		if (dojo.byId('username').value.length == 0) {
			document.getElementById('loginFailedMessage').innerHTML = messages.username_required;
			showLoginErrorMessage();
			rc = false;
		}
		return rc;
	}	
   
    function loadCssFile(css) {
		var link = document.createElement('link');
		link.rel = 'stylesheet';
		link.href = css;
		link.type = 'text/css';
		link.media = 'screen';
		link.charset = 'utf-8';
		document.getElementsByTagName('head')[0].appendChild(link);
    }
	
	function setProductLabel(){
		var isBpmAdvOnly ="<%=configService.getString("com.ibm.bspace.is_adv_only ")%>";	
		if(isBpmAdvOnly =="true"){
			document.getElementById("productLabel").innerHTML="BPM";
		} 
	}
 </script>
    
<!-- BS scripts - end -->

</head>

<body scroll='no' onload="" style="height:100%; width:100%; margin: 0px" class="<%=rtlClass%>" id="login">
<%
if (configService.getString("com.ibm.bspace.configuration.env") != null && (configService.getString("com.ibm.bspace.configuration.env").equals("bpm_adv") || configService.getString("com.ibm.bspace.configuration.env").equals("bpm_std"))) {
%>
<div class="login_background_image">
<%
} else { 
%>
<div style="height:100%;width:100%;position:absolute; top: 0px; left:0px; z-index:1000; background-color:white" class="loginCurtain"></div>
<div class="topDiv" role="region" aria-label="Login to Business Space">
<table height="100%" width="100%" align="center" style="position:static;" cellpadding="0" cellspacing="0">
<tr height="0">
<td>
<div>
<table id="table1" width="100%" border="0" cellspacing="0" cellpadding="0">
	<tr>
	</tr>
</table>
<br>
<table style="width: 100%; height: 100%; margin: 0px;" border="0">
		<tbody>
			<tr>
				<td>
				&nbsp;
				</td>
				<td width="1px">
					<table cellpadding="0" cellspacing="0" border="0">				
						<tbody>
							<tr style="vertical-align: top;">
								<td id="loginBox">
									<div class="login-bg">
									<div class="login-top-spacer">
									<span class="login-high-contrast bspace-text1">Business Space</span>
									</div>

<% 
}

   if (com.ibm.mm.framework.Platform.getInstance().isSecurityEnabled()) {
	// Social Portal style
	if (configService.getString("com.ibm.bspace.configuration.env") != null && (configService.getString("com.ibm.bspace.configuration.env").equals("bpm_adv") || configService.getString("com.ibm.bspace.configuration.env").equals("bpm_std"))) {
%>
			<!-- d104158: Keep the form name in sync with login_footer.jsp -->
			<form id="loginForm" name="login-form" method="post" action="<%= response.encodeURL("j_security_check") %>">
				<div class="login_content" role="main" aria-label="BPM Process Portal login">

			<!--	
				BPM Advanced only version should not display 'Process Portal' on the login page. 
				The text 'Process Portal' can be displayed for BPM Advanced and Std 
 			-->
					<div class="login_header" >
						<div class="login_ibm_logo"><img src="<%=mmContextRoot%>/contenthandler/mm/dav/filestore/login/bspace/images/login_logo.png" width="180" height="105" alt="IBM logo"/></div>
						<div id="productLabel" class="BPM_process_portal_text">BPM  |   Process Portal</div>
					</div>
				
					<script type="text/javascript">
					setProductLabel();
					</script>
					<div class="popup_window">
					<div class="login_window_content">
						<div id="loginFailedMessage" style="display:none">
						</div>
						<div class="login_username_field">
							<label for="username" class="loginText" id="user_id"></label>
							<input id="username" class="login-field" type="text" name="j_username" autocapitalize="off" />
						</div>
						<div class="login_password_field">
							<label for="password" class="loginText" id="password_label"></label>
							<input name="j_password" id="password" type="password" class="login-field" autocomplete="off"></input>
						</div>
						<input id="log_in" class="btn" type="submit" name="save" value="" onclick="prepareBeforeSubmitLogin(); return false;"></input>
					</div>
				</div>
				<div class="legal_text">
					<p id="copyrights" class="legal_text" role="contentinfo"></p>
				</div>				
			</form>	
			<table cellpadding="0" cellspacing="0">
			<tbody>
				<tr id="CRspacer" valign="top">
					<td>
						<img src="<%=bspaceContextRoot%>login/images/blank.gif" width="33" height="1" alt=""/>
					</td>
					<td id="spacer"> 
					</td>
					<!-- d104158: The following td element is a dummy one just to honor the variables used from inside login_footer.jsp -->
					<td>
						<!-- Defect 47448: APAR JR30897 -->
						<!-- enclose mashups msgs in a hidden div so they are never shown -->
						<div style="display:none">
							<div id="signErrorDiv" style="color: red; display: inline; width: 435px; display: none;"></div>
							<div id="signErrorMsg" style="display: none;"></div>
						</div>
					</td>
				</tr>
				<tr id="CRspacer2" valign="top">
					<td>
						<img src="<%=bspaceContextRoot%>login/images/blank.gif" width="33" height="1" alt=""/>
					</td>
				</tr>				
			</tbody>
			</table>
<%
	// Bspace style
	} else {
%>
			<!-- d104158: Keep the form name in sync with login_footer.jsp -->
			<form id="loginForm" name="login-form" method="post" action="<%= response.encodeURL("j_security_check") %>">
				<table cellspacing=0 cellpadding=0 border=0>
				<tbody>
				<tr>
				<td><img src="<%=bspaceContextRoot%>login/images/blank.gif" width="33" height="1" alt=""/><label for="username" class="loginText" id="user_id"></label></td>
				</tr>
				<tr><td id="spacer2" height='0px'></td></tr> <!-- ADS spacer2 -->
				<tr>
				<td><img src="<%=bspaceContextRoot%>login/images/blank.gif" width="33" height="1" alt=""/><input id="username" class="login-field" type="text" name="j_username" autocapitalize="off"></input></td>
				</tr>
				<tr><td height='10px'><img src='<%=bspaceContextRoot%>login/images/blank.gif' alt=""></img></td></tr>
				<tr>
				<td><img src="<%=bspaceContextRoot%>login/images/blank.gif" width="33" height="1" alt=""/><label for="password" class="loginText" id="password_label"></label></td>
				</tr>
				<tr><td id="spacer3" height='0px'></td></tr> <!-- ADS spacer3 -->
				<tr>
				<td><img src="<%=bspaceContextRoot%>login/images/blank.gif" width="33" height="1" alt=""/><input name="j_password" id="password" type="password" class="login-field" autocomplete="off"></input></td>
				</tr>
				<tr><td height='15px'><img src='<%=bspaceContextRoot%>login/images/blank.gif' alt=""></img></td></tr>
				<tr>
				
				<!-- ADS - Not available in iteration 2
				
				<td><img src="<%=bspaceContextRoot%>login/images/blank.gif" width="33" height="1" alt=""/><input name="j_lastpage" id="j_lastpage" type="checkbox" class="login-field" onclick="return storeSettings();" onchange="storeSettings();"></input><label for="j_lastpage" class="editFieldLabel" id="returnToLastPage"></label></td>
				
				-->
				
				</tr>
				<tr><td id="spacer4" height='5px'></td></tr> <!-- ADS spacer4 -->
				<tr>
				<!-- d104158: onclick should return false to avoid double submit. -->
				<td><img src="<%=bspaceContextRoot%>login/images/blank.gif" width="31" height="1" alt=""/><input id="log_in" class ="btn" type="submit" name="save" value="" onclick="prepareBeforeSubmitLogin(); return false;"></input></td>
				</tr>
				</tbody>
				</table>
			</form>	
			<table cellpadding="0" cellspacing="0">
			<tbody>
				<tr id="CRspacer" valign="top">
					<td>
						<img src="<%=bspaceContextRoot%>login/images/blank.gif" width="33" height="1" alt=""/>
					</td>
					<td>
						<div id="loginFailedMessage" style="color: red; display: inline; width: 435px; display: none;">
						</div>
					</td>
					<!-- d104158: The following td element is a dummy one just to honor the variables used from inside login_footer.jsp -->
					<td>
						<!-- Defect 47448: APAR JR30897 -->
						<!-- enclose mashups msgs in a hidden div so they are never shown -->
						<div style="display:none">
							<div id="signErrorDiv" style="color: red; display: inline; width: 435px; display: none;"></div>
							<div id="signErrorMsg" style="display: none;"></div>
						</div>
					</td>
				</tr>
				<tr id="CRspacer2" valign="top">
					<td>
						<img src="<%=bspaceContextRoot%>login/images/blank.gif" width="33" height="1" alt=""/>
					</td>
				</tr>				
			</tbody>
			</table>	
<%	
	}
%>

<%
   } else {
	 	String formActionURL = mmContextRoot + "/mmLogin"; //$NON-NLS-1$
%>
			<form id="unsecure_form_login" method="post" action="<%out.print(formActionURL);%>"> 
				<table cellspacing=0 cellpadding=0 border=0>
				<tbody>
				<tr>
				<td><img src="<%=bspaceContextRoot%>login/images/blank.gif" width="33" height="1" alt=""/><label for="username" class="loginText" id="user_id"></label></td>
				</tr>
				<tr><td id="spacer2" height='0px'></td></tr> <!-- ADS spacer2 -->
				<tr>
				<td><img src="<%=bspaceContextRoot%>login/images/blank.gif" width="33" height="1" alt=""/><input id="username" name="j_username" class="login-field" type="text" autocapitalize="off"></input>
				</td>
				</tr>
				<tr><td height='10px'><img src='<%=bspaceContextRoot%>login/images/blank.gif' alt=""></img></td></tr>
				<tr><td id="spacer4" height='5px'></td></tr> <!-- ADS spacer4 -->
				<tr>
				<td><img src="<%=bspaceContextRoot%>login/images/blank.gif" width="33" height="1" alt=""/><input id="log_in" class ="btn" type="submit" name="save" value="" onclick="return prepareBeforeSubmitLoginUnsecure()"></input></td>
				</tr>
				</tbody>
				</table>
			</form>
			<table cellpadding="0" cellspacing="0">
			<tbody>
				<tr valign="top">
					<td>
						<div style="height: 100px">
						<img id="CRspacerUnsecure" src="<%=bspaceContextRoot%>login/images/blank.gif" width="33" height="1" alt=""/>
						<span id="loginFailedMessage" style="color: red; width: 435px; display: none;">xxx</span>
						</div>
					</td>
				</tr>
			</tbody>
			</table>			
<%
   }
%>


<%
if (configService.getString("com.ibm.bspace.configuration.env") != null && (configService.getString("com.ibm.bspace.configuration.env").equals("bpm_adv") || configService.getString("com.ibm.bspace.configuration.env").equals("bpm_std"))) {
%>
</div>
</div>
<%
} else {
%>
				<div class="login-copyright">
				<br><span style="vertical-align: bottom; font-size:11px; padding-left: 5px; padding-right: 5px;" id="copyrights" role="contentinfo"></span>
				</div>
			</div>
				<div style="padding-top:8px;">
					<div class="ibm-logo"></div>
					<div class="websphere-logo"></div>
				</div>
								</td>
							</tr>
						</tbody>
					</table>
				</td>

				<td>
				&nbsp;
				</td>
			</tr>
		</tbody>
	</table>
</div>
</td>
</tr>
</table>
</div>
<%
}
%>

		<%-- Required login footer JSP, do not remove! --%>
		<%@include file="login_footer.jsp" %>
	</body>
</html>

<!-- BS scripts - start -->

<script type="text/javascript">
	var spacer = document.getElementById('CRspacer');
	var spacerUnsecure = document.getElementById('CRspacerUnsecure');
	var spacer2 = document.getElementById('spacer2');
       	
		if (dojo.isIE)
		{
			if (spacer != null)
	       		spacer.style.height = '1px';
       		
			if (spacerUnsecure != null)
	       		spacerUnsecure.style.height = '70px';

			if (spacer2 != null)
		       	spacer2.style.height = '15px';       		
		}
	    else
	    {
			if (spacer != null)
		       	spacer.style.height = '1px';

			if (spacerUnsecure != null)
				spacerUnsecure.style.height = '90px';
	    }

   	nlsFix('welcome');
	nlsFix('user_id');
	nlsFix('password_label');
	nlsFix('log_in');
	nlsFix('copyrights');
	<% 
	   if (com.ibm.mm.framework.Platform.getInstance().isSecurityEnabled()) 
	   {
	%>	
		document.getElementById('loginFailedMessage').appendChild(document.createTextNode(messages.login_error));
		document.getElementById('loginFailedMessage').setAttribute("aria-label", messages.login_error);
		document.getElementById('loginFailedMessage').setAttribute("role", "alert");
        document.getElementById('loginFailedMessage').setAttribute("aria-live", "assertive");
		document.getElementById('loginFailedMessage').style.fontFamily = 'Arial, Verdana';
		document.getElementById('loginFailedMessage').style.fontSize = '11px';
<%
	   }
%>
	

	var bspaceEnvironment = "<%=configService.getString("com.ibm.bspace.configuration.env")%>";
	if (bspaceEnvironment == "bpm_adv" || bspaceEnvironment == "bpm_std") {
		dojo.addClass(document.body, "processPortal");
	} else {
		dojo.addClass(document.body, "bspace");
		bspaceEnvironment = "bspace";
	}	
	com.ibm.bspace.common.util.ui.Helper.loadStyleSheet();
	com.ibm.bspace.common.util.ui.Helper.wrapElement(document.getElementById('username'));
	com.ibm.bspace.common.util.ui.Helper.wrapElement(document.getElementById('password'));
	com.ibm.bspace.common.util.ui.Helper.wrapElement(document.getElementById('log_in'));

	document.getElementById('username').focus();
	
	// Fix ie6 focus problem
	if(dojo.isIE)
	{	
		setTimeout(
			function()
			{
				var username_field = document.getElementById('username');
				username_field.focus();
				username_field.select();
			}
		, 1);
	}

	// Always load the default login.css
	loadCssFile("<%=mmContextRoot%>/contenthandler/mm/dav/filestore/login/bspace/login.css");	

	// Load the CSS and icon from the folder specified in the com.ibm.bspace.login.style location if it is provided and not the default of "bspace"
	var bspaceLoginStyle = "<%=configService.getString("com.ibm.bspace.login.style")%>";
	if (bspaceLoginStyle == "null" || bspaceLoginStyle == "bspace"){
		document.write('<link rel="icon" href="<%=mmContextRoot%>/contenthandler/mm/dav/filestore/login/bspace/images/WBS.ico" type="image/x-icon"/>');
	}
	else {
		loadCssFile("<%=mmContextRoot%>/contenthandler/mm/dav/filestore/login/" + bspaceLoginStyle + "/login.css");
		document.write('<link rel="icon" href="<%=mmContextRoot%>/contenthandler/mm/dav/filestore/login/' + bspaceLoginStyle + '/images/WBS.ico" type="image/x-icon"/>');
	}

	loadCssFile("<%=bspaceContextRoot%>com/ibm/bspace/common/util/ui/css/commonUI.css");
	
	if (bspaceEnvironment == "bpm_adv" || bspaceEnvironment == "bpm_std") {
		var faviconLinks = dojo.query('[type$=\"image/x-icon\"]');
		if (faviconLinks) {
			for (var link=0; link<faviconLinks.length; link++) {
				faviconLinks[link].href = "<%=mmContextRoot%>/contenthandler/mm/dav/filestore/login/bspace/images/portal.ico";
			}
		}
	}	
	
	var locale = dojo.locale;
	if ((locale.length > 2) && (locale.charAt(2) == '-')) {
		locale = locale.substring(0,2) + '_' + locale.substring(3).toUpperCase(); 
	}
	document.documentElement.setAttribute('lang',locale);
	document.documentElement.setAttribute('xml:lang',locale);
	if ((locale == 'ar') || (locale == 'iw') || (locale == 'he')) {
		document.body.setAttribute('dir','rtl');
	}	
</script>

<!-- Displays error message for invalid userid and/or password -->
<%
	if (isErrorScreen)
	{
%>
	<script language="JavaScript" type="text/javascript">
		document.getElementById('loginFailedMessage').style.display = '';
			
	</script>
<%
	}
%>

<!-- BS scripts - end -->
