dojo.provide("com.ibm.mm.builder.spaceEditorWidget");
dojo.require("com.ibm.mm.builder.iwidget.spacemanager.widget.ThemesListControl");
dojo.require("com.ibm.mm.builder.iwidget.spacemanager.widget.IconsListControl");
dojo.require("com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerConstants");
dojo.declare("com.ibm.mm.builder.spaceEditorWidget",null,{WID:null,SPACE_CREATE_TYPE_EMPTY:"from_empty",SPACE_CREATE_TYPE_TEMPLATE:"from_template",resourceBundle:null,ownerName:null,ownerId:null,title:null,theme:null,icon:null,description:null,spaceModel:null,space:null,resourceMessage:null,user:null,acModel:null,eventService:com.ibm.mashups.services.ServiceManager.getService(com.ibm.mashups.iwidget.services.EventService.SERVICE_NAME),propChanged:{titleChanged:false,descChanged:false,ownerChanged:false,themeChanged:false,iconChanged:false},onLoad:function(){
this._connections=[];
this._subscriptions=[];
var _1=this.iContext.widgetId;
this.WID="_"+_1+"_";
this.resourceBundle=com.ibm.mm.builder.coreWidgetsStrings;
this.resourceMessage=com.ibm.mm.builder.coreWidgetsMessages;
var _2=dojo.byId(this.WID+"themesContainer");
this.themesListControl=new com.ibm.mm.builder.iwidget.spacemanager.widget.ThemesListControl({widgetId:_1},_2);
dijit.setWaiState(this.themesListControl.domNode,"labelledby",this.WID+"choose_theme_label");
var _3=dojo.byId(this.WID+"iconsContainer");
this.iconsListControl=new com.ibm.mm.builder.iwidget.spacemanager.widget.IconsListControl({widgetId:_1},_3);
dijit.setWaiState(this.iconsListControl.domNode,"labelledby",this.WID+"choose_icon_label");
this.spaceModel=com.ibm.mm.builder.utils.spaceUtil.getSpaceModel();
this._subscriptions.push(dojo.subscribe("com.ibm.mm.builder.spaceEditorWidget.OwnerName",dojo.hitch(this,this._setOwnerName)));
this._subscriptions.push(dojo.subscribe("com.ibm.mm.builder.spaceEditorWidget.OwnerId",dojo.hitch(this,this._changeOwnerId)));
this._subscriptions.push(dojo.subscribe("com.ibm.mm.builder.spaceEditorWidget.ChangePermission",dojo.hitch(this,this._changePermission)));
},_changePermission:function(_4){
var _5=com.ibm.mashups.enabler.ac.RoleType.EDITOR;
var _6=com.ibm.mashups.enabler.ac.RoleType.USER;
var _7=com.ibm.mm.builder.utils.acModelUtil;
this.setRoleToNone=false;
var _8={};
var _9=this.acModel.getOwner();
if(_9){
_8[_9.getID()]="user";
}
if(_4=="none"){
_7.removeMembersWithRoleType(this.acModel,_6,_8);
_7.removeMembersWithRoleType(this.acModel,_5,_8);
this.setRoleToNone=true;
}else{
if(_4==_5){
_7.removeMembersWithRoleType(this.acModel,_6,_8);
_7.insertMemberWithRoleType(this.acModel,_8,_5);
}else{
if(_4==_6){
_7.removeMembersWithRoleType(this.acModel,_5,_8);
_7.insertMemberWithRoleType(this.acModel,_8,_6);
}
}
}
this.acModel.commit().start();
},_onLoadChangeOwnerWithKey:function(e){
if(e.charCode==dojo.keys.SPACE||e.keyCode==dojo.keys.ENTER){
this.onLoadChangeOwner(e);
}
},onLoadChangeOwner:function(){
var _a={widgetTypeId:"spaceChangeOwnerWidget",eventName:"com.ibm.mashups.builder.spaceChangeOwner",eventPayload:this.ownerId,dialogParam:{title:this.resourceBundle.CHANGE_SPACE_OWNER_CAPTION,nodeWidth:"500px",leftBarWidth:"0px",rightBarWidth:"0px",containerBackgroundColor:"white",hasRightBottomResizer:false}};
this.eventService.broadcastEvent("com.ibm.mashups.builder.displayInMashupDialog",_a);
},onView:function(){
dojo.parser.parse(this.iContext.getRootElement());
this._spaceNameField=dojo.byId(this.WID+"SpaceName");
this._connections.push(dojo.connect(this._spaceNameField,"onkeypress",this,"onPressEnter"));
dojo.byId(this.WID+"space_information_label").innerHTML=this.resourceBundle.EDIT_SPACE_INFORMATION;
dojo.byId(this.WID+"space_theme_label").innerHTML=this.resourceBundle.EDIT_SPACE_THEME;
dojo.byId(this.WID+"space_icon_label").innerHTML=this.resourceBundle.EDIT_SPACE_ICON;
dojo.byId(this.WID+"space_name_label").innerHTML=this.resourceBundle.CREATE_SPACE_NAME;
dojo.byId(this.WID+"space_desc_label").innerHTML=this.resourceBundle.CREATE_SPACE_DESC;
dojo.byId(this.WID+"space_owner").innerHTML=this.resourceBundle.EDIT_SPACE_OWNER;
dojo.byId(this.WID+"choose_theme_label").innerHTML=this.resourceBundle.EDIT_SPACE_CHOOSE_THEME;
dojo.byId(this.WID+"choose_icon_label").innerHTML=this.resourceBundle.EDIT_SPACE_CHOOSE_ICON;
dojo.byId(this.WID+"change_text").innerHTML=this.resourceBundle.EDIT_SPACE_CHANGEOWNER;
},onPressEnter:function(_b){
if(_b.keyCode==13){
this.save();
}
},onEditSpace:function(_c){
if(_c.payload&&_c.payload.spaceId){
this.spaceId=_c.payload.spaceId;
this.editSpaceInSpaceManager=true;
}else{
this.spaceId=_c.payload;
this.editSpaceInSpaceManager=false;
}
this.cleanUI();
this.space=com.ibm.mm.builder.utils.spaceUtil.getSpaceNode(this.spaceId);
this.loadThemes();
this.loadIcons();
this.loadSpaceModel();
for(var p in this.propChanged){
if(Object.prototype.hasOwnProperty.call(this.propChanged,p)){
this.propChanged[p]=false;
}
}
if(!this._canChangeOwner()){
dojo.style(dojo.byId(this.WID+"change_text"),"display","none");
}else{
dojo.style(dojo.byId(this.WID+"change_text"),"display","");
}
},saveSpaceModel:function(){
this.space.setTitle(this.title,dojo.locale);
this.space.setDescription(this.description,dojo.locale);
com.ibm.mm.builder.utils.spaceUtil.setSpaceIconURL(this.space,this.iconUrlEncode(this.icon));
com.ibm.mm.builder.utils.spaceUtil.getSpaceModel().commit().start();
if(!this.userModel){
this.userModel=com.ibm.mashups.enabler.user.Factory.getUserModel();
}
var _d=com.ibm.mm.builder.utils.navigationUtil;
var _e=_d.getNavigationModel();
var _f=_e.find(this.space.getRootNavigation()).start();
_f.setTheme(this.theme);
_e.commit().start();
if(this.ownerId!==null&&this.ownerId!==""){
this.eventService.broadcastEvent("com.ibm.mashups.builder.savePage");
this.user=this.userModel.find(this.ownerId).start();
this.acModel.setOwner(this.user);
var _10=this.acModel.commit();
_10.start();
}
var _11=this.space.getID();
if(this.propChanged.ownerChanged){
var _12=com.ibm.mm.builder.utils.spaceUtil.getSpaceNode(_11);
var _13=false;
if(_12){
var ea=com.ibm.mashups.enabler.ac.AccessFactory.getEffectiveAccess(_12);
_13=ea?ea.hasRole("ADMINISTRATOR"):false;
}
var _14=false;
if(this.setRoleToNone){
var _15=com.ibm.mm.builder.utils.spaceUtil;
_14=_13?false:true;
}
var _14=_13?false:this.setRoleToNone;
dojo.publish(com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerConstants.Topic.Space["delete"],[_11]);
dojo.publish(com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerConstants.Topic.Space.refresh,[com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerConstants.Action.CHANGE_OWNER,{spaceId:_11,needRemoveSpace:_14}]);
if(!this.editSpaceInSpaceManager){
this.eventService.broadcastEvent("com.ibm.mashups.builder.switchSpace",com.ibm.mm.builder.utils.spaceUtil.getHomeSpaceId()||com.ibm.mm.builder.utils.spaceUtil.getWelcomeSpaceId());
}else{
var _16=com.ibm.mm.builder.utils.spaceUtil.getCurrentSpaceId();
this.eventService.broadcastEvent("com.ibm.mashups.builder.spacemanager.spaceOwnerChanged",{spaceId:_11,currentSpaceId:_16});
}
if(_11==com.ibm.mm.builder.utils.spaceUtil.getCurrentSpaceId()&&this.setRoleToNone==true){
var _12=com.ibm.mm.builder.utils.spaceUtil.getSpaceNode(_11);
if(!_13){
this.eventService.broadcastEvent("com.ibm.mashups.builder.switchSpace",com.ibm.mm.builder.utils.spaceUtil.getHomeSpaceId()||com.ibm.mm.builder.utils.spaceUtil.getWelcomeSpaceId());
}
}
}
var _17=null;
if(this.propChanged.themeChanged){
if(this.propChanged.titleChanged){
this.eventService.broadcastEvent("com.ibm.mashups.builder.refreshSpaceSelector");
_17={"id":this.spaceId,"title":this.title};
dojo.publish(com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerConstants.Topic.Space.changeSpaceTitle,[_17]);
}
}else{
if(this.propChanged.titleChanged){
this.eventService.broadcastEvent("com.ibm.mashups.builder.refreshSpaceSelector");
_17={"id":this.spaceId,"title":this.title};
dojo.publish(com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerConstants.Topic.Space.changeSpaceTitle,[_17]);
dojo.publish(com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerConstants.Topic.Space.refresh,[com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerConstants.Action.EDIT_SPACE,{spaceId:_11}]);
}else{
if(this.propChanged.descChanged||this.propChanged.iconChanged){
dojo.publish(com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerConstants.Topic.Space.refresh,[com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerConstants.Action.EDIT_SPACE,{spaceId:_11}]);
}
}
}
},loadSpaceModel:function(){
if(!this.space){
return;
}
this.acModel=com.ibm.mashups.enabler.ac.AccessControlModelFactory.getAccessControlModel(this.space);
if(this.space){
this._setTitle(com.ibm.mm.builder.utils.htmlUtil.unEscapeString(com.ibm.mm.builder.utils.enablerUtil.getNodeTitle(this.space)));
this._setDescription(com.ibm.mm.builder.utils.htmlUtil.unEscapeString(com.ibm.mm.builder.utils.enablerUtil.getNodeDescription(this.space)));
var _18=com.ibm.mm.builder.utils.spaceUtil.getSpaceIconURL(this.space);
if(_18){
this._setSelectedIcon(this.iconUrlDecode(_18));
}
if(this.acModel.getOwner()!==null&&this.acModel.getOwner()!==""){
this._setOwnerId(this.acModel.getOwner().getID());
this._setOwnerName(this.acModel.getOwner().getDisplayName());
}else{
dojo.byId(this.WID+"space_owner").innerHTML=this.resourceBundle.EDIT_NO_SPACE_OWNER;
}
}else{
return;
}
},loadThemes:function(){
var _19=this.space.getRootNavigation().getID();
var _1a=com.ibm.mm.builder.utils.pageUtil;
var _1b=_1a.getPageNode(_19);
var _1c=_1b.getTheme();
if(!_1c){
var _1d=com.ibm.mm.builder.utils.themeUtil;
_1c=_1d.getDefaultThemeId();
}
this.theme=_1c;
this.themesListControl.refresh(_1c);
},loadIcons:function(){
this.iconsListControl.refresh();
},cleanUI:function(){
dojo.byId(this.WID+"SpaceName").value="";
dojo.byId(this.WID+"SpaceDesc").value="";
},_getTitle:function(){
return dojo.byId(this.WID+"SpaceName").value;
},_getDescription:function(){
return dojo.byId(this.WID+"SpaceDesc").value;
},_getSpaceOwner:function(){
return dojo.byId(this.WID+"space_owner_value").innerHTML;
},_getSelectedTheme:function(){
return this.themesListControl.selectedTheme;
},_getSelectedIcon:function(){
return this.iconsListControl.getSelectedIconId();
},_getOwnerId:function(){
return this.ownerId;
},iconUrlDecode:function(_1e){
var _1f=_1e.lastIndexOf("/");
var _20=_1e.lastIndexOf(".");
return (_1e.substring(_1f+6,_20));
},iconUrlEncode:function(_21){
return builderConfig.builderPath+"/images/spaceicons/icon-"+_21+".gif";
},hide:function(){
if(this.messageControl){
this.messageControl.hide();
}
this.eventService.broadcastEvent("com.ibm.mashups.builder.closeMashupDialog",this.iContext.widgetId);
},_verifyInput:function(_22,_23){
var _24=dojo.byId(this.WID+"SpaceName");
var _25=dojo.byId(this.WID+"SpaceDesc");
if(!_22||dojo.trim(_22)===""){
dojo.attr(_24,"aria-invalid","true");
this.messageControl.attr("message",this.resourceMessage.E_SPACE_MANAGER_SPACE_NAME_IS_REQUIRED_0);
this.messageControl.show();
return false;
}
if(!com.ibm.mm.builder.utils.spaceUtil.validateSpaceName(_22)){
dojo.attr(_24,"aria-invalid","true");
return false;
}
dojo.removeAttr(_24,"aria-invalid");
if(_23&&dojo.isString(_23)){
if(_23.length>=512){
dojo.attr(_25,"aria-invalid","true");
this.messageControl.attr("message",this.resourceMessage.E_SPACE_MANAGER_SPACE_DESC_HAS_MAX_LIMIT_0);
this.messageControl.show();
return false;
}
}
dojo.removeAttr(dojo.byId(this.WID+"SpaceDesc"),"aria-invalid");
return true;
},save:function(){
if(!this.messageControl){
dojo.registerModulePath("com.ibm.lotus.oneui.v100.messages",this.iContext.io.rewriteURI("../dijit-library/oneUI.versionized/messages"));
dojo.require("com.ibm.lotus.oneui.v100.messages.Message");
this.messageControl=new com.ibm.lotus.oneui.v100.messages.Message({messageType:"error"},this.WID+"messageBox");
this.messageControl.hide();
}
if(!this._verifyInput(this._getTitle(),this._getDescription())){
return;
}
if(this.title!=this._getTitle()){
this.propChanged.titleChanged=true;
}
this.title=this._getTitle();
if(this.description!=this._getDescription()){
this.propChanged.descChanged=true;
}
this.description=this._getDescription();
if(this.theme!=this._getSelectedTheme()){
this.propChanged.themeChanged=true;
}
this.theme=this._getSelectedTheme();
if(this.icon!=this._getSelectedIcon()){
this.propChanged.iconChanged=true;
}
this.icon=this._getSelectedIcon();
this.saveSpaceModel();
this.messageControl.hide();
this.hide();
},_setOwnerName:function(_26){
this.ownerName=_26;
dojo.byId(this.WID+"space_owner_value").innerHTML=_26;
},_setOwnerId:function(id){
this.ownerId=id;
},_changeOwnerId:function(id){
if(this.ownerId!=id){
this.propChanged.ownerChanged=true;
}
this.ownerId=id;
},_canChangeOwner:function(){
return com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerActions.space.canChangeOwner(this.spaceId);
},_setSelectedTheme:function(_27){
this.theme=_27;
this.themesListControl.setSelectedTheme(_27);
},_setDescription:function(_28){
if(!_28){
_28="";
}
this.description=_28;
dojo.byId(this.WID+"SpaceDesc").value=this.description;
},_setTitle:function(_29){
this.title=_29;
dojo.byId(this.WID+"SpaceName").value=this.title;
},_setSelectedIcon:function(_2a){
this.icon=_2a;
this.iconsListControl.setSelectedIcon(_2a);
},onUnload:function(){
dojo.forEach(this._connections,dojo.disconnect);
dojo.forEach(this._subscriptions,dojo.unsubscribe);
this.iconsListControl.destroy();
}});

